(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("jxon"));
	else if(typeof define === 'function' && define.amd)
		define("lib-bb-portal-rest", ["jxon"], factory);
	else if(typeof exports === 'object')
		exports["lib-bb-portal-rest"] = factory(require("jxon"));
	else
		root["lib-bb-portal-rest"] = factory(root["jxon"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_8__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(1);

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	exports.default = function (cnf) {
	  var config = (0, _config2.default)(cnf);
	  config.plugin.log('Configuration', config);
	  var doRequest = function doRequest(reqObj) {
	    return runMiddleware(config, reqObj).then(function (reqSessionObj) {
	      return config.plugin.request(reqSessionObj, config.plugin.log).then(function (response) {
	        return (0, _response2.default)(config, reqSessionObj, response);
	      });
	    });
	  };
	
	  var BBRest = (0, _chain2.default)(config, doRequest);
	  BBRest.config = config;
	  // a method that is auto executing BBRest chain by parsing xml payload
	  BBRest.auto = (0, _auto2.default)(BBRest, config.plugin.get);
	
	  return BBRest;
	};
	
	var _config = __webpack_require__(2);
	
	var _config2 = _interopRequireDefault(_config);
	
	var _chain = __webpack_require__(4);
	
	var _chain2 = _interopRequireDefault(_chain);
	
	var _response = __webpack_require__(9);
	
	var _response2 = _interopRequireDefault(_response);
	
	var _auto = __webpack_require__(12);
	
	var _auto2 = _interopRequireDefault(_auto);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	/**
	 * @module lib-bb-portal-rest
	 * @description
	 * Provide a cross-platform interface and fixes REST API inconsistencies of Backbase Portal Rest
	 *
	 * @example
	 * import bbrest from 'lib-bb-portal-rest';
	 * import * as browserPlugin from 'to-be-made';
	 *
	 * const BBRest = bbrest({ portal: 'my-portal', plugin: browserPlugin });
	 * BBRest.importItem().file('item.zip').post()
	 *   .then(response => {
	 *     // do something
	 *   });
	 */
	
	
	/**
	 * @typedef requestCallback
	 * @type {function}
	 * @description Executes http request
	 * @param {object} config request configuration
	 * @param {string} config.url url to request
	 * @param {string} config.method http method
	 * @param {object} config.query query hash
	 * @param {object} config.headers headers hash
	 * @param {string} config.body request body
	 * @param {string} config.importFile path of the file to upload
	 * @param {string} config.exportFile file path to download to
	 * @param {string} config.formField name of the form field for upload
	 * @returns {promise} promise of the request
	 */
	
	/**
	 * @typedef getCallback
	 * @type {function}
	 * @description returns the payload to send as a request body
	 * @param {string} fileOrUrl path of the file or url to return
	 * @returns {promise} promise
	 */
	
	/**
	 * @typedef urlParseCallback
	 * @type {function}
	 * @description parses the url
	 * @param {string} urlString url
	 * @returns {object} object containing url components, as nodejs url.parse
	 */
	
	/**
	 * @typedef logCallback
	 * @type {function}
	 * @description logs message with header
	 * @param {string} header title of the message
	 * @param {string} message message to log
	 */
	
	/**
	 * @typedef btoaCallback
	 * @type {function}
	 * @description returns a base-64 encoded ASCII string from a String object
	 * @param {string} string to encode
	 * @returns {string} encodedString
	 */
	var runMiddleware = function runMiddleware(config, reqObj) {
	  return config.middleware.reduce(function (acc, middleware) {
	    return acc.then(function (reqo) {
	      return middleware(config, reqo);
	    });
	  }, Promise.resolve(reqObj));
	};
	
	/**
	 * @name bbrest
	 * @type {function}
	 * @description BBRest constructor
	 * @param {object} config Configuration object
	 * @param {string} config.scheme url scheme
	 * @param {string} config.host url host
	 * @param {string} config.port url port
	 * @param {string} config.context url path prefix (portal context)
	 * @param {string} config.username username
	 * @param {string} config.password password
	 * @param {string} config.authPath url path for authorization
	 * @param {string} config.portal portal name
	 * @param {boolean} config.outputJxon when true, xml output will be parsed and returned as jxon
	 * @param {boolean} config.verbose enables logging
	 * @param {array} config.middleware List of middlewares to execute before main request
	 * @param {object} config.plugin js module exposing cross platform methods
	 * @param {requestCallback} config.plugin.request http request method
	 * @param {getCallback} config.plugin.get get method
	 * @param {urlParseCallback} config.plugin.urlParse url parse method
	 * @param {logCallback} config.plugin.log log method
	 * @param {btoaCallback} config.plugin.btoa base64 string convert method
	 */

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = parseConfig;
	
	var _session = __webpack_require__(3);
	
	var _session2 = _interopRequireDefault(_session);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var defaults = {
	  scheme: 'http',
	  host: 'localhost',
	  port: '7777',
	  context: 'portalserver',
	  username: 'developer',
	  password: 'developer',
	  authPath: '${contextRoot}/j_spring_security_check',
	  portal: '',
	  outputJxon: true,
	  verbose: false,
	  middleware: [_session2.default]
	};
	
	function parseConfig(cnf) {
	  if (!{}.hasOwnProperty.call(cnf, 'plugin')) {
	    throw new Error('Configuration object must define plugin property');
	  }
	  var config = Object.assign({}, defaults, cnf);
	
	  var logIsDefined = {}.hasOwnProperty.call(cnf.plugin, 'log');
	
	  if (cnf.verbose) {
	    if (!logIsDefined) {
	      config.plugin.log = console.log;
	    }
	  } else {
	    config.plugin.log = function () {};
	  }
	  // avoid breaking change
	  config.authPath = config.authPath.replace('${contextRoot}', config.context);
	  return config;
	}

/***/ },
/* 3 */
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
	
	function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
	
	var sessionHeaders = void 0;
	
	var urlEncodeHash = function urlEncodeHash(hash) {
	  var keys = Object.keys(hash);
	  if (keys.length) {
	    var encoded = keys.map(function (key) {
	      return encodeURIComponent(key) + '=' + encodeURIComponent(hash[key]);
	    });
	    return encoded.join('&');
	  }
	  return '';
	};
	
	var unquote = function unquote(str) {
	  return str.charAt(0) === '"' ? str.slice(1, -1) : str;
	};
	
	var parseCookie = function parseCookie(str) {
	  return str.split(';').map(function (v) {
	    return v.trim().split('=');
	  }).map(function (v) {
	    return [v[0], v.splice(1).join('=')];
	  }).map(function (_ref) {
	    var _ref2 = _slicedToArray(_ref, 2),
	        name = _ref2[0],
	        value = _ref2[1];
	
	    return [name, unquote(value)];
	  }).reduce(function (acc, _ref3) {
	    var _ref4 = _slicedToArray(_ref3, 2),
	        name = _ref4[0],
	        value = _ref4[1];
	
	    return Object.assign(acc, _defineProperty({}, name.trim(), value.trim()));
	  }, {});
	};
	
	var mergeHeaders = function mergeHeaders(target, heads) {
	  var merged = Object.assign({}, target, heads);
	  if (target.Cookie && heads.Cookie) {
	    (function () {
	      var tCook = parseCookie(target.Cookie);
	      var hCook = parseCookie(heads.Cookie);
	      var cookies = Object.assign(tCook, hCook);
	      merged.Cookie = Object.keys(cookies).reduce(function (acc, name) {
	        return acc.concat(name + '=' + cookies[name]);
	      }, []).join('; ');
	    })();
	  }
	  return merged;
	};
	
	var getAuthUri = function getAuthUri(cfg) {
	  return cfg.scheme + '://' + cfg.host + ':' + cfg.port + '/' + cfg.authPath;
	};
	
	var getSession = function getSession(config, reqObj) {
	  return new Promise(function (resolve, reject) {
	    var reqo = Object.assign({}, reqObj);
	    if (sessionHeaders) {
	      reqo.headers = mergeHeaders(reqo.headers, sessionHeaders);
	      resolve(reqo);
	    } else {
	      var headers = {
	        'user-agent': 'bb-cli 2'
	      };
	
	      var sessReqObj = {
	        url: getAuthUri(config),
	        method: 'POST',
	        headers: headers
	      };
	
	      if (sessReqObj.url.indexOf('spring_security_check') > -1) {
	        var base64 = config.plugin.btoa(config.username + ':' + config.password);
	        sessReqObj.headers.Authorization = 'Basic ' + base64;
	        sessReqObj.method = 'GET';
	      } else {
	        sessReqObj.body = urlEncodeHash({
	          username: config.username,
	          password: config.password
	        });
	        sessReqObj.headers['Content-Type'] = 'application/x-www-form-urlencoded';
	      }
	
	      config.plugin.request(sessReqObj, config.plugin.log).then(function (res) {
	        sessionHeaders = {
	          Cookie: res.headers['set-cookie'],
	          'user-agent': 'bb-cli 2'
	        };
	
	        var csrf = res.headers['x-bbxsrf'];
	        if (csrf) {
	          sessionHeaders['X-BBXSRF'] = csrf;
	        }
	
	        config.plugin.log('Session Headers', sessionHeaders);
	        reqo.headers = mergeHeaders(reqo.headers, sessionHeaders);
	        resolve(reqo);
	      }).catch(reject);
	    }
	  });
	};
	
	exports.default = getSession;

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _portal = __webpack_require__(5);
	
	var _portal2 = _interopRequireDefault(_portal);
	
	var _http = __webpack_require__(6);
	
	var _http2 = _interopRequireDefault(_http);
	
	var _utils = __webpack_require__(7);
	
	var utils = _interopRequireWildcard(_utils);
	
	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var getUri = function getUri(config, uri) {
	  var cfg = Object.assign({}, config);
	  if (uri[0] === 'orchestrator' && cfg.orchestrator) cfg = Object.assign(cfg, cfg.orchestrator);
	  return cfg.scheme + '://' + cfg.host + ':' + cfg.port + '/' + cfg.context + '/' + uri.join('/');
	};
	
	/**
	 * opts:
	 * uri - url path components
	 * qs - query hash
	 * method - http method
	 * headers - http headers
	 * importFile
	 * exportFile
	 */
	var getReqObject = function getReqObject(config, opts, payload) {
	  var reqObj = {
	    url: getUri(config, opts.uri),
	    method: opts.method,
	    query: opts.qs,
	    headers: opts.headers
	  };
	
	  if (opts.importFile) {
	    reqObj.importFile = opts.importFile;
	    reqObj.formField = reqObj.url.indexOf('import/package') === -1 ? 'file' : 'package';
	  } else if (opts.exportFile) {
	    reqObj.exportFile = opts.exportFile;
	  }
	
	  return utils.getPayload(payload, config.plugin.get).then(function (xmlString) {
	    reqObj.body = xmlString;
	    return reqObj;
	  });
	};
	
	var getBbrestChain = function getBbrestChain(config, doRequest) {
	  var httpCallback = function httpCallback(opts, payload) {
	    return getReqObject(config, opts, payload).then(doRequest);
	  };
	  var portalCallback = function portalCallback(cmnd, path) {
	    return (0, _http2.default)(cmnd, path, config, httpCallback);
	  };
	  return (0, _portal2.default)(config, portalCallback);
	};
	
	exports.default = getBbrestChain;

/***/ },
/* 5 */
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = BBRest;
	function BBRest(config, callback) {
	  return {
	    server: function server() {
	      return callback('server', ['portals']);
	    },
	    portal: function portal() {
	      var a = ['portals', config.portal];
	      return callback('portal', a);
	    },
	    catalog: function catalog(item) {
	      var a = ['catalog'];
	      if (item) a.push(item);
	      return callback('server', a);
	    },
	    portalCatalog: function portalCatalog(item) {
	      var a = ['portals', config.portal, 'catalog'];
	      if (item) a.push(item);
	      return callback('portal', a);
	    },
	    container: function container(containerName) {
	      var a = ['portals', config.portal, 'containers'];
	      if (containerName) a.push(containerName);
	      return callback('container', a);
	    },
	    widget: function widget(widgetName) {
	      var a = ['portals', config.portal, 'widgets'];
	      if (widgetName) a.push(widgetName);
	      return callback('widget', a);
	    },
	    page: function page(pageName) {
	      var a = ['portals', config.portal, 'pages'];
	      if (pageName) a.push(pageName);
	      return callback('page', a);
	    },
	    link: function link(linkName) {
	      var a = ['portals', config.portal, 'links'];
	      if (linkName) a.push(linkName);
	      return callback('link', a);
	    },
	    user: function user(userName, showGroups, groupName) {
	      var a = ['users'];
	      if (userName) a.push(userName);
	      if (showGroups) a.push('groups');
	      if (groupName) a.push(groupName);
	      return callback('user', a);
	    },
	    group: function group(groupName, showUsers, userName) {
	      var a = ['groups'];
	      if (groupName) a.push(groupName);
	      if (showUsers) a.push('users');
	      if (userName) a.push(userName);
	      return callback('group', a);
	    },
	    template: function template(templateName) {
	      var a = ['templates'];
	      if (templateName) a.push(templateName);
	      return callback('template', a);
	    },
	    audit: function audit(meta) {
	      return callback('audit', [meta ? 'auditmeta' : 'auditevents']);
	    },
	    cache: function cache(type) {
	      var a = ['caches', type];
	      return callback('cache', a);
	    },
	    import: function _import() {
	      var a = ['import', 'portal'];
	      return callback('import', a);
	    },
	    importItem: function importItem(toPortal) {
	      var a = ['import', 'package'];
	      if (toPortal) a.push(config.portal);
	      return callback('importItem', a);
	    },
	    export: function _export(uuid) {
	      var a = void 0;
	      if (uuid) {
	        a = ['orchestrator', 'export', 'files', uuid];
	        return callback('export', a);
	      }
	      a = ['export', 'portal'];
	      return callback('export', a);
	    },
	    exportItem: function exportItem(itemName, fromPortal) {
	      var a = ['export', 'package'];
	      if (fromPortal) a.push(config.portal);
	      a.push(itemName);
	      return callback('exportItem', a);
	    }
	  };
	}

/***/ },
/* 6 */
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	exports.default = function (command, path, config, callback) {
	  var opts = {
	    uri: path.concat(),
	    qs: {},
	    headers: {
	      'Content-Type': 'application/xml'
	    }
	  };
	
	  return {
	    rights: function rights() {
	      opts.uri.push('rights');
	      return this;
	    },
	    tag: function tag(tagName, tagType) {
	      opts.uri.push('tags');
	      if (tagName) opts.uri.push(tagName);
	      if (tagType) opts.qs.type = tagType;
	      return this;
	    },
	    query: function query(o) {
	      Object.assign(opts.qs, o);
	      return this;
	    },
	    file: function file(_file) {
	      if (opts.uri[0] === 'import') {
	        opts.headers['Content-Type'] = 'multipart/form-data';
	        opts.headers.Connection = 'keep-alive';
	        if (opts.uri[1] !== 'package') {
	          opts.uri = ['orchestrator', 'import', 'upload'];
	        }
	        opts.importFile = _file;
	      } else {
	        opts.exportFile = _file;
	      }
	      return this;
	    },
	    get: function get() {
	      var uri = opts.uri;
	      /* methods that use .xml:
	       * portal().xml().get()
	       * portalCatalog('item').get()
	       * container('name').xml().get()
	       * widget('name').xml().get()
	       * page('name').xml().get()
	       * link('name').xml().get() */
	      if (uri[0] === 'portals' && uri.length === 2) uri[1] += '.xml';
	      if (uri[2] === 'catalog' && uri[3]) uri[3] += '.xml';
	      if (uri[4] !== 'rights') {
	        if (uri[2] === 'pages' && uri[3]) uri[3] += '.xml';
	        if (uri[2] === 'containers' && uri[3]) uri[3] += '.xml';
	        if (uri[2] === 'widgets' && uri[3]) uri[3] += '.xml';
	        if (uri[2] === 'links' && uri[3]) uri[3] += '.xml';
	      }
	      opts.method = 'GET';
	      if (command === 'export') {
	        opts.qs = Object.assign(opts.qs, { portalName: config.portal, includeGroups: true });
	      }
	      return callback(opts, undefined);
	    },
	    post: function post(payload) {
	      opts.method = 'POST';
	      if (opts.uri[0] === 'export' && opts.uri[1] !== 'package') {
	        opts.uri = ['orchestrator', 'export', 'exportrequests'];
	      }
	      return callback(opts, payload);
	    },
	    put: function put(payload) {
	      opts.method = 'PUT';
	      return callback(opts, payload);
	    },
	
	    // fixing inconsistencies in API
	    // server /delete/catalog POST
	    // portal /portals/[portal_name]/delete/catalog POST
	    // link /portals/[portal_name]/delete/links POST
	    delete: function _delete(payload) {
	      opts.method = 'DELETE';
	      if (payload) {
	        opts.method = 'POST';
	        switch (command) {
	          case 'server':
	            opts.uri = ['delete', 'catalog'];
	            break;
	          case 'portal':
	            opts.uri[2] = 'delete';
	            opts.uri[3] = 'catalog';
	            break;
	          case 'link':
	            opts.uri[2] = 'delete';
	            opts.uri[3] = 'links';
	            break;
	          default:
	          // code
	        }
	      }
	      if (command === 'cache' && opts.uri[1] === 'all') {
	        return this.deleteAllCache(0);
	      }
	      return callback(opts, payload);
	    },
	    deleteAllCache: function deleteAllCache(i) {
	      var t = this;
	      opts.uri[1] = cch[i];
	      return callback(opts, '').then(function (v) {
	        if (i < cch.length - 1) return t.deleteAllCache(i + 1);
	        return v;
	      }).catch(function (r) {
	        if (r.response.status === 404 && i < cch.length - 1) return t.deleteAllCache(i + 1);
	        return r;
	      });
	    }
	  };
	};
	
	// cache names for deleteAll
	var cch = ['globalModelCache', 'retrievedWidgetCache', 'widgetChromeStaticCache', 'serverSideClosureCache', 'urlLevelCache', 'contentTemplateCache', 'webCache', 'gModelCache', 'uuidFromExtendedItemNamesCache', 'springAclCacheRegion', 'springAclSidCacheRegion', 'contextNameToItemNameToUuidCache', 'widgetCache', 'uuidToContentReferencesCache', 'itemUuidToReferencingLinkUuidsCache', 'uuidToCacheKeysCache', 'versionBundleCache'];

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; // jxon is not a vendor library (yet) so we declared is as devDependency
	// eslint-disable-next-line import/no-extraneous-dependencies
	
	
	exports.jsToString = jsToString;
	exports.stringToJs = stringToJs;
	exports.getPayload = getPayload;
	
	var _jxon = __webpack_require__(8);
	
	var _jxon2 = _interopRequireDefault(_jxon);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var lastError = void 0;
	_jxon2.default.config({
	  parserErrorHandler: function onError(level, msg) {
	    lastError.level = level;
	    lastError.msg = msg;
	  }
	});
	
	function jsToString(js) {
	  try {
	    var ret = _jxon2.default.jsToString(js);
	    if (ret[0] !== '<') throw new Error('Invalid parameter:');
	    return ret;
	  } catch (err) {
	    var e = new Error('jxon.jsToString error\n' + err.message + '\n' + JSON.stringify(js));
	    e.error = err;
	    throw e;
	  }
	}
	function stringToJs(str) {
	  try {
	    if (typeof str !== 'string') throw new TypeError('Invalid parameter:');
	    if (!str.length) return {};
	    lastError = {};
	    var ret = void 0;
	    if (typeof DOMParser !== 'undefined') {
	      // if runs in browser
	      var xml = _jxon2.default.stringToXml(str);
	      var el = xml.getElementsByTagName('parsererror');
	      ret = _jxon2.default.xmlToJs(xml);
	
	      if (el.length > 0) {
	        lastError.level = 'fatalError';
	        lastError.msg = _jxon2.default.xmlToJs(el[0]).div._;
	      }
	    } else {
	      ret = _jxon2.default.stringToJs(str);
	    }
	    if (lastError.level && lastError.level !== 'warning') throw new Error(lastError.msg);
	    return ret;
	  } catch (err) {
	    var e = new Error('jxon.stringToJs error\n' + err.message + '\n' + JSON.stringify(str));
	    e.error = err;
	    throw e;
	  }
	}
	
	function getPayload(payload, get) {
	  return new Promise(function (resolve) {
	    var type = typeof payload === 'undefined' ? 'undefined' : _typeof(payload);
	
	    if (type === 'object') {
	      // is jxon
	      resolve(jsToString(payload));
	    } else if (type === 'string') {
	      if (payload.trim().charAt(0) === '<') {
	        // is xml string
	        resolve(payload);
	      } else {
	        resolve(get(payload)); // is path or url
	      }
	    } else {
	      resolve('');
	    }
	  });
	}

/***/ },
/* 8 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_8__;

/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = parseResponse;
	
	var _utils = __webpack_require__(7);
	
	var utils = _interopRequireWildcard(_utils);
	
	var _xx = __webpack_require__(10);
	
	var _xx2 = _interopRequireDefault(_xx);
	
	var _xx3 = __webpack_require__(11);
	
	var _xx4 = _interopRequireDefault(_xx3);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }
	
	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
	
	var CXPError = function (_Error) {
	  _inherits(CXPError, _Error);
	
	  function CXPError(message, raw, toSend, config) {
	    _classCallCheck(this, CXPError);
	
	    var _this = _possibleConstructorReturn(this, (CXPError.__proto__ || Object.getPrototypeOf(CXPError)).call(this, message + ' ' + toSend.url));
	
	    _this.response = raw;
	    _this.request = toSend;
	    _this.config = config;
	    if (typeof Error.captureStackTrace === 'function') {
	      Error.captureStackTrace(_this, _this.constructor.name);
	    }
	    return _this;
	  }
	
	  return CXPError;
	}(Error);
	
	var getContentType = function getContentType(headers) {
	  var typeHeader = headers['content-type'];
	  return typeHeader ? typeHeader.split(';')[0] : '';
	};
	
	var matchError = function matchError(matches, headers, body) {
	  var contentType = getContentType(headers);
	
	  var match = matches.find(function (item) {
	    return body.indexOf(item.search) > -1 && item.contentType === contentType;
	  });
	  if (match) return match.callback(body);
	  return false;
	};
	
	/*
	 * config - bbrest main config object(scheme, host etc)
	 * toSend - object passed to plugin.request(url, method, query, headers...)
	 * res - response object(status, statusText, headers, body)
	 */
	function parseResponse(config, toSend, res) {
	  config.plugin.log('Response', res);
	  var errorMessage = void 0;
	
	  if (res.status >= 200 && res.status < 300) {
	    errorMessage = matchError(_xx2.default, res.headers, res.body);
	    if (errorMessage) {
	      throw new CXPError(errorMessage, res, toSend, config);
	    }
	    // download
	    if (getContentType(res.headers) === 'application/octet-stream') return toSend.file;
	
	    if (config.outputJxon) {
	      return utils.stringToJs(res.body);
	    }
	    return res.body;
	  } else if (res.status >= 300 && res.status < 400) {
	    var href = config.plugin.urlParse(res.headers.location);
	    throw new CXPError('CXPRedirect: ' + href.query.errorMessage, res, toSend, config);
	  } else if (res.status >= 400 && res.status < 500) {
	    throw new CXPError(res.status + ' ' + res.statusText, res, toSend, config);
	  }
	  errorMessage = matchError(_xx4.default, res.headers, res.body);
	  if (errorMessage) {
	    throw new CXPError(errorMessage, res, toSend, config);
	  }
	  throw new CXPError(res.status + ' ' + res.statusText, res, toSend, config);
	}

/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _utils = __webpack_require__(7);
	
	exports.default = [{
	  contentType: 'text/html',
	  search: '<form action="/portalserver/j_spring_security_check" method="POST"',
	  callback: function callback() {
	    return 'HTML Error: Invalid Session';
	  }
	}, {
	  contentType: 'text/html',
	  search: 'class="bd-errorMsg"',
	  callback: function callback(body) {
	    var jx = (0, _utils.stringToJs)(body);
	    var p = jx.html.body.div.div.p[1];
	    return 'HTML Error: ' + p._;
	  }
	}, {
	  contentType: 'application/xml',
	  search: '<level>ERROR</level>',
	  callback: function callback(body) {
	    var jx = (0, _utils.stringToJs)(body);
	    var msg = jx.import.message;
	    return 'HTML Error: ' + msg;
	  }
	}];

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _utils = __webpack_require__(7);
	
	exports.default = [{
	  contentType: 'text/html',
	  search: '<title>Error 500 Server Error</title>',
	  callback: function callback(body) {
	    var jx = (0, _utils.stringToJs)(body);
	    var p = jx.html.body.p._;
	    var pre = jx.html.body.pre.join('\n');
	    return 'Server Error: ' + p + pre;
	  }
	}, {
	  contentType: 'application/xml',
	  search: '<errorMessage><message>',
	  callback: function callback(body) {
	    var jx = (0, _utils.stringToJs)(body);
	    var msg = jx.errorMessage.message;
	    return 'Server Error: ' + msg;
	  }
	}];

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _utils = __webpack_require__(7);
	
	var utils = _interopRequireWildcard(_utils);
	
	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }
	
	var getMethods = function getMethods(xmlString) {
	  var jx = utils.stringToJs(xmlString);
	  var aKey = Object.keys(jx)[0];
	  var bKey = Object.keys(jx[aKey])[0];
	  var context = jx[aKey][bKey].contextItemName;
	  var items = ['container', 'widget', 'page', 'link', 'template', 'user', 'group'];
	  var method = void 0;
	  var httpMethod = void 0;
	
	  switch (aKey) {
	    case 'catalog':
	      if (context === '[BBHOST]') {
	        method = 'catalog';
	        httpMethod = 'post';
	      } else {
	        method = 'portalCatalog';
	        httpMethod = 'post';
	      }
	      break;
	    case 'portals':
	      method = 'server';
	      httpMethod = 'post';
	      break;
	    case 'portal':
	      method = 'server';
	      httpMethod = 'put';
	      break;
	    default:
	      {
	        var plural = aKey.charAt(aKey.length - 1) === 's';
	        if (plural) {
	          if (aKey.substr(0, aKey.length - 1) === bKey) {
	            method = bKey;
	            httpMethod = 'post';
	          } else {
	            throw new Error(aKey + ' must be plural of ' + bKey);
	          }
	        } else {
	          if (items.indexOf(aKey) !== -1) {
	            method = aKey;
	            httpMethod = 'put';
	          } else {
	            method = aKey;
	            httpMethod = 'post';
	          }
	        }
	        break;
	      }
	  }
	
	  return {
	    method: method,
	    httpMethod: httpMethod
	  };
	};
	
	var getAuto = function getAuto(BBRest, get) {
	  return function (payload, overrideMethod) {
	    return utils.getPayload(payload, get).then(function (xmlString) {
	      var _getMethods = getMethods(xmlString),
	          method = _getMethods.method,
	          httpMethod = _getMethods.httpMethod;
	
	      return BBRest[method]()[overrideMethod || httpMethod](xmlString);
	    });
	  };
	};
	
	exports.default = getAuto;

/***/ }
/******/ ])
});
;
//# sourceMappingURL=lib-bb-portal-rest.js.map